﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Media;
using Buddy.Coroutines;
using ff14bot;
using ff14bot.AClasses;
using ff14bot.Behavior;
using ff14bot.Enums;
using ff14bot.Helpers;
using ff14bot.Managers;
using ff14bot.Objects;
using ff14bot.RemoteWindows;
using Newtonsoft.Json;
using TreeSharp;
using System.Diagnostics;

namespace ChocoboCompanionStanceDancerPlugin
{
    public class ChocoboCompanionStanceDancerPlugin : BotPlugin
    {
        #region Properties
        
        private static bool CanSummonChocobo
        {
            get
            {
                return ((!PartyManager.IsInParty || PartyManager.NumMembers < 4) && Chocobo.CanSummon && !MovementManager.IsMoving);
            }
        }

        private static bool ExceededThreshold
        {
            get
            {
                var currentHealth = Core.Me.CurrentHealthPercent;
                if (Settings.Instance.CheckChocoboHealth && Chocobo.Object != null)
                {
                    if (Chocobo.Object.CurrentHealthPercent < currentHealth) currentHealth = Chocobo.Object.CurrentHealthPercent;
                }
                if (Settings.Instance.CheckPartyHealth && PartyManager.NumMembers > 2)
                {
                    foreach (var partyMember in PartyManager.VisibleMembers)
                    {
                        if (partyMember.GameObject != null && partyMember.GameObject.Type != GameObjectType.BattleNpc && partyMember.GameObject.CurrentHealthPercent < currentHealth) currentHealth = partyMember.GameObject.CurrentHealthPercent;
                    }
                }
                //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] Health currently " + currentHealth.ToString());

                if (lowestThreshold1 != 0 && currentHealth < lowestThresholdValue1)
                {
                    //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) lowestThreshold1 currently " + lowestThreshold1.ToString());
                    //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) lowestThresholdValue1 currently " + lowestThresholdValue1.ToString());
                    if (Chocobo.Stance != lowestThreshold1)
                    {
                        stanceToSet = lowestThreshold1;
                        //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) stanceToSet currently " + stanceToSet.ToString());
                        return true;
                    }
                    else return false;
                }
                if (lowestThreshold2 != 0 && currentHealth < lowestThresholdValue2)
                {
                    //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) lowestThreshold2 currently " + lowestThreshold2.ToString());
                    //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) lowestThresholdValue2 currently " + lowestThresholdValue2.ToString());
                    if (Chocobo.Stance != lowestThreshold2 && Chocobo.Stance != lowestThreshold1)
                    {
                        stanceToSet = lowestThreshold2;
                        //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) stanceToSet currently " + stanceToSet.ToString());
                        return true;
                    }
                    else return false;
                }
                if (lowestThreshold3 != 0 && currentHealth < lowestThresholdValue3)
                {
                    //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) lowestThreshold3 currently " + lowestThreshold3.ToString());
                    //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) lowestThresholdValue3 currently " + lowestThresholdValue3.ToString());
                    if (Chocobo.Stance != lowestThreshold3 && Chocobo.Stance != lowestThreshold2 && Chocobo.Stance != lowestThreshold1)
                    {
                        stanceToSet = lowestThreshold3;
                        //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) stanceToSet currently " + stanceToSet.ToString());
                        return true;
                    }
                    else return false;
                }
                if (lowestThreshold4 != 0 && currentHealth < lowestThresholdValue4)
                {
                    //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) lowestThreshold4 currently " + lowestThreshold4.ToString());
                    //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) lowestThresholdValue4 currently " + lowestThresholdValue4.ToString());
                    if (Chocobo.Stance != lowestThreshold4 && Chocobo.Stance != lowestThreshold3 && Chocobo.Stance != lowestThreshold2 && Chocobo.Stance != lowestThreshold1)
                    {
                        stanceToSet = lowestThreshold4;
                        //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) stanceToSet currently " + stanceToSet.ToString());
                        return true;
                    }
                    else return false;
                }
                if (highestThreshold1 != 0 && currentHealth > highestThresholdValue1)
                {
                    //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) highestThreshold1 currently " + highestThreshold1.ToString());
                    //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) highestThresholdValue1 currently " + highestThresholdValue1.ToString());
                    if (Chocobo.Stance != highestThreshold1)
                    {
                        stanceToSet = highestThreshold1;
                        //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) stanceToSet currently " + stanceToSet.ToString());
                        return true;
                    }
                    else return false;
                }
                if (highestThreshold2 != 0 && currentHealth > highestThresholdValue2)
                {
                    //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) highestThreshold2 currently " + highestThreshold2.ToString());
                    //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) highestThresholdValue2 currently " + highestThresholdValue2.ToString());
                    if (Chocobo.Stance != highestThreshold2 && Chocobo.Stance != highestThreshold1)
                    {
                        stanceToSet = highestThreshold2;
                        //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) stanceToSet currently " + stanceToSet.ToString());
                        return true;
                    }
                    else return false;
                }
                if (highestThreshold3 != 0 && currentHealth > highestThresholdValue3)
                {
                    //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) highestThreshold3 currently " + highestThreshold3.ToString());
                    //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) highestThresholdValue3 currently " + highestThresholdValue3.ToString());
                    if (Chocobo.Stance != highestThreshold3 && Chocobo.Stance != highestThreshold2 && Chocobo.Stance != highestThreshold1)
                    {
                        stanceToSet = highestThreshold3;
                        //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) stanceToSet currently " + stanceToSet.ToString());
                        return true;
                    }
                    else return false;
                }
                if (highestThreshold4 != 0 && currentHealth > highestThresholdValue4)
                {
                    //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) highestThreshold4 currently " + highestThreshold4.ToString());
                    //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) highestThresholdValue4 currently " + highestThresholdValue4.ToString());
                    if (Chocobo.Stance != highestThreshold4 && Chocobo.Stance != highestThreshold3 && Chocobo.Stance != highestThreshold2 && Chocobo.Stance != highestThreshold1)
                    {
                        stanceToSet = highestThreshold4;
                        //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (ExceededThreshold) stanceToSet currently " + stanceToSet.ToString());
                        return true;
                    }
                    else return false;
                }

                return false;
            }
        }

        public static CompanionStance stanceToSet = 0;
        //private static Stopwatch timer;

        public static CompanionStance lowestThreshold1 = 0;
        public static CompanionStance lowestThreshold2 = 0;
        public static CompanionStance lowestThreshold3 = 0;
        public static CompanionStance lowestThreshold4 = 0;
        public static CompanionStance highestThreshold1 = 0;
        public static CompanionStance highestThreshold2 = 0;
        public static CompanionStance highestThreshold3 = 0;
        public static CompanionStance highestThreshold4 = 0;

        public static float lowestThresholdValue1 = 0;
        public static float lowestThresholdValue2 = 0;
        public static float lowestThresholdValue3 = 0;
        public static float lowestThresholdValue4 = 0;
        public static float highestThresholdValue1 = 100;
        public static float highestThresholdValue2 = 100;
        public static float highestThresholdValue3 = 100;
        public static float highestThresholdValue4 = 100;

        #endregion

        #region Summon Chocobo Logic

        private static async Task<bool> SummonChocobo()
        {
            //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer]  Chocobo.Summoned currently " + Chocobo.Summoned);

            if (FishingManager.State != FishingState.None)
            {
                Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] Waiting until we are done fishing to summon chocobo..");
                return false;
            }

            if (GatheringManager.WindowOpen)
            {
                Logging.Write(Colors.Aqua, "[ChocoboCompanionStanceDancer] Currently Gathering Items, waiting until we are done to summon chocobo.");
                return false;
            }

            if (CraftingManager.IsCrafting)
            {
                Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] Currently Crafting Items, waiting until we are done to summon chocobo.");
                return false;
            }

            if (CraftingLog.IsOpen)
            {
                Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] Closing Crafting Log so we can summon chocobo.");
                CraftingLog.Close();
            }

            if (Core.Me.IsMounted)
            {
                Logging.Write(Colors.Aqua, "[ChocoboCompanionStanceDancer] Dismounting so we can summon chocobo.");
                await CommonTasks.StopAndDismount();
            }



            foreach (BagSlot slot in ff14bot.Managers.InventoryManager.FilledSlots)
            {
                if (slot.RawItemId == 4868)
                {
                    await SummonChocoboNow();
                    return false;
                }
            }

            Logging.Write(Colors.Aqua, "[ChocoboCompanionStanceDancer] No Gysahl Greens; please purchase some so we can summon chocobo.");
            return false;
        }


        private static async Task<bool> SummonChocoboNow()
        {
            Logging.Write(Colors.BlanchedAlmond, "[ChocoboCompanionStanceDancer] Now summoning chocobo");
            Chocobo.Summon();
            await Coroutine.Wait(1000, () => Chocobo.Summoned);
            /*if (!Chocobo.Summoned)
            {
                return await SummonChocobo();
            };*/
            return false;
        }

        #endregion

            #region Change Stance Logic

        private static async Task<bool> CheckStance()
        {
            //Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] (CheckStance) stanceToSet currently " + stanceToSet.ToString());

            if (FishingManager.State != FishingState.None)
            {
                Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] Quitting fishing so we can change stances.");
                Actionmanager.DoAction(299, Core.Me);
                await Coroutine.Wait(5000, () => FishingManager.State == FishingState.None);
            }

            if (GatheringManager.WindowOpen)
            {
                Logging.Write(Colors.Aqua, "[ChocoboCompanionStanceDancer] Currently Gathering Items, waiting until we are done so we can change stances.");
                return false;
            }

            if (CraftingManager.IsCrafting)
            {
                Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] Currently Crafting Items, waiting until we are done so we can change stances.");
                return false;
            }

            if (CraftingLog.IsOpen)
            {
                Logging.Write(Colors.Pink, "[ChocoboCompanionStanceDancer] Closing Crafting Log so we can change stances.");
                CraftingLog.Close();
            }

            if (Core.Me.IsMounted)
            {
                Logging.Write(Colors.Aqua, "[ChocoboCompanionStanceDancer] Dismounting so we can change stances.");
                await CommonTasks.StopAndDismount();
            }

            if (stanceToSet != 0) await ChangeStance(stanceToSet);

            return false;
        }

        private static async Task<bool> ChangeStance(CompanionStance stance)
        {
            Logging.Write(Colors.BlanchedAlmond, "[ChocoboCompanionStanceDancer] Now changing stance to " + stance.ToString());
            switch(stance)
            {
                case CompanionStance.Healer:
                    Chocobo.HealerStance();
                    await Coroutine.Wait(2000, () => Chocobo.Stance == CompanionStance.Healer);
                    break;
                case CompanionStance.Defender:
                    Chocobo.DefenderStance();
                    await Coroutine.Wait(2000, () => Chocobo.Stance == CompanionStance.Defender);
                    break;
                case CompanionStance.Attacker:
                    Chocobo.AttackerStance();
                    await Coroutine.Wait(2000, () => Chocobo.Stance == CompanionStance.Attacker);
                    break;
                case CompanionStance.Free:
                    Chocobo.FreeStance();
                    await Coroutine.Wait(2000, () => Chocobo.Stance == CompanionStance.Free);
                    break;
                default:
                    break;
            }
            return false;
        }

        #endregion

        #region Fields

        private Composite _coroutine;
        private Composite _coroutine2;
        private Gui _settingsForm;

        #endregion

        #region Required Overrides

        public override string Author
        {
            get { return "Cloud30000"; }
        }

        public override string Name
        {
            get { return "ChocoboCompanionStanceDancer"; }
        }

        public override Version Version
        {
            get { return new Version(1, 0, 0, 0); }
        }

        #endregion

        #region Optional Overrides

        public override void OnInitialize()
        {
            Gui.LoadThresholdOrders();
            _coroutine = new Decorator(c => (Core.Me.IsAlive && Chocobo.Summoned && ExceededThreshold), new ActionRunCoroutine(r => CheckStance()));
            _coroutine2 = new Decorator(c => (Core.Me.IsAlive && !Chocobo.Summoned && Settings.Instance.SummonChocobo && CanSummonChocobo), new ActionRunCoroutine(r => SummonChocobo()));
        }

        public override void OnEnabled()
        {
            TreeRoot.OnStart += OnBotStart;
            TreeRoot.OnStop += OnBotStop;
            TreeHooks.Instance.OnHooksCleared += OnOnHooksCleared;

            if (TreeRoot.IsRunning)
            {
                AddHooks();
            }
            Gui.LoadThresholdOrders();
        }

        public override void OnDisabled()
        {
            TreeRoot.OnStart -= OnBotStart;
            TreeRoot.OnStop -= OnBotStop;
            TreeHooks.Instance.OnHooksCleared -= OnOnHooksCleared;
            RemoveHooks();
        }

        public override void OnShutdown()
        {
            TreeRoot.OnStart -= OnBotStart;
            TreeRoot.OnStop -= OnBotStop;
            TreeHooks.Instance.OnHooksCleared -= OnOnHooksCleared;
            RemoveHooks();
        }

        public override bool WantButton
        {
            get { return true; }
        }

        public override void OnButtonPress()
        {
            if (_settingsForm == null || _settingsForm.IsDisposed || _settingsForm.Disposing)
                _settingsForm = new Gui();

            _settingsForm.ShowDialog();
        }

        #endregion

        #region Hook Logic

        private void AddHooks()
        {
            //Logging.Write(Colors.Aqua, "Adding ChocoboCompanionStanceDancer Hook");
            TreeHooks.Instance.InsertHook("TreeStart", 0, _coroutine);
            TreeHooks.Instance.InsertHook("TreeStart", 1, _coroutine2);
        }

        private void RemoveHooks()
        {
            //Logging.Write(Colors.Aqua, "Removing ChocoboCompanionStanceDancer Hook");
            TreeHooks.Instance.RemoveHook("TreeStart", _coroutine);
            TreeHooks.Instance.RemoveHook("TreeStart", _coroutine2);
        }

        #endregion

        #region Event Handlers

        private void OnBotStop(BotBase bot)
        {
            RemoveHooks();
        }

        private void OnBotStart(BotBase bot)
        {
            AddHooks();
        }

        private void OnOnHooksCleared(object sender, EventArgs e)
        {
            AddHooks();
        }

        #endregion
    }

    #region Settings Class

    public class Settings : JsonSettings
    {
        [JsonIgnore]
        private static Settings _instance;
        public Settings(string filename)
            : base(Path.Combine(CharacterSettingsDirectory, "ChocoboCompanionStanceDancer.json"))
        {
        }

        public static Settings Instance
        {
            get { return _instance ?? (_instance = new Settings("Settings")); }
        }

        [Setting]
        [DefaultValue(true)]
        public bool HealerThresholdUseDrop { get; set; }
        [Setting]
        [DefaultValue(false)]
        public bool AttackerThresholdUseDrop { get; set; }
        [Setting]
        [DefaultValue(false)]
        public bool DefenderThresholdUseDrop { get; set; }
        [Setting]
        [DefaultValue(false)]
        public bool FreeThresholdUseDrop { get; set; }
        [Setting]
        [DefaultValue(50.0f)]
        public float HealerThreshold { get; set; }
        [Setting]
        [DefaultValue(80.0f)]
        public float AttackerThreshold { get; set; }
        [Setting]
        [DefaultValue(80.0f)]
        public float DefenderThreshold { get; set; }
        [Setting]
        [DefaultValue(80.0f)]
        public float FreeThreshold { get; set; }
        [Setting]
        [DefaultValue(false)]
        public bool UseHealerStance { get; set; }
        [Setting]
        [DefaultValue(false)]
        public bool UseAttackerStance { get; set; }
        [Setting]
        [DefaultValue(false)]
        public bool UseDefenderStance { get; set; }
        [Setting]
        [DefaultValue(false)]
        public bool UseFreeStance { get; set; }
        [Setting]
        [DefaultValue(false)]
        public bool CheckChocoboHealth { get; set; }
        [Setting]
        [DefaultValue(false)]
        public bool CheckPartyHealth { get; set; }
        [Setting]
        [DefaultValue(false)]
        public bool SummonChocobo { get; set; }
    }

    #endregion
}