﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using ff14bot.Managers;
using ff14bot.Enums;

namespace ChocoboCompanionStanceDancerPlugin
{
    public partial class Gui : Form
    {
        public Gui()
        {
            InitializeComponent();

            checkBoxHealer.Checked = false;
            checkBoxAttacker.Checked = false;
            checkBoxDefender.Checked = false;
            checkBoxFree.Checked = false;

            LoadThresholdOrders();

            comboBoxHealer.SelectedIndex = Settings.Instance.HealerThresholdUseDrop == true ? 0 : 1;
            comboBoxAttacker.SelectedIndex = Settings.Instance.AttackerThresholdUseDrop == true ? 0 : 1;
            comboBoxDefender.SelectedIndex = Settings.Instance.DefenderThresholdUseDrop == true ? 0 : 1;
            comboBoxFree.SelectedIndex = Settings.Instance.FreeThresholdUseDrop == true ? 0 : 1;

            HealerThresholdUpDown.Value = (decimal)Settings.Instance.HealerThreshold;
            AttackerThresholdUpDown.Value = (decimal)Settings.Instance.AttackerThreshold;
            DefenderThresholdUpDown.Value = (decimal)Settings.Instance.DefenderThreshold;
            FreeThresholdUpDown.Value = (decimal)Settings.Instance.FreeThreshold;

            LoadThresholdOrders();

            checkBoxHealer.Checked = Settings.Instance.UseHealerStance;
            checkBoxAttacker.Checked = Settings.Instance.UseAttackerStance;
            checkBoxDefender.Checked = Settings.Instance.UseDefenderStance;
            checkBoxFree.Checked = Settings.Instance.UseFreeStance;
            checkBoxChocoboHealth.Checked = Settings.Instance.CheckChocoboHealth;
            checkBoxPartyHealth.Checked = Settings.Instance.CheckPartyHealth;
            checkBoxSummonChocobo.Checked = Settings.Instance.SummonChocobo;

            LoadThresholdOrders();
        }

        private void comboBoxHealer_SelectionChangeCommitted(object sender, EventArgs e)
        {
            HealerThresholdUpDown.Value = CheckThresholdValue(HealerThresholdUpDown.Value, Settings.Instance.HealerThresholdUseDrop);
            Settings.Instance.HealerThresholdUseDrop = comboBoxHealer.SelectedIndex == 0 ? true : false;
            Settings.Instance.Save();
            LoadThresholdOrders();
        }

        private void comboBoxAttacker_SelectionChangeCommitted(object sender, EventArgs e)
        {
            AttackerThresholdUpDown.Value = CheckThresholdValue(AttackerThresholdUpDown.Value, Settings.Instance.AttackerThresholdUseDrop);
            Settings.Instance.AttackerThresholdUseDrop = comboBoxAttacker.SelectedIndex == 0 ? true : false;
            Settings.Instance.Save();
            LoadThresholdOrders();
        }

        private void comboBoxDefender_SelectionChangeCommitted(object sender, EventArgs e)
        {
            DefenderThresholdUpDown.Value = CheckThresholdValue(DefenderThresholdUpDown.Value, Settings.Instance.DefenderThresholdUseDrop);
            Settings.Instance.DefenderThresholdUseDrop = comboBoxDefender.SelectedIndex == 0 ? true : false;
            Settings.Instance.Save();
            LoadThresholdOrders();
        }

        private void comboBoxFree_SelectionChangeCommitted(object sender, EventArgs e)
        {
            FreeThresholdUpDown.Value = CheckThresholdValue(FreeThresholdUpDown.Value, Settings.Instance.FreeThresholdUseDrop);
            Settings.Instance.FreeThresholdUseDrop = comboBoxFree.SelectedIndex == 0 ? true : false;
            Settings.Instance.Save();
            LoadThresholdOrders();
        }

        private void checkBoxHealer_CheckedChanged(object sender, EventArgs e)
        {
            HealerThresholdUpDown.Value = CheckThresholdValue(HealerThresholdUpDown.Value, Settings.Instance.HealerThresholdUseDrop);
            Settings.Instance.UseHealerStance = checkBoxHealer.Checked;
            Settings.Instance.Save();
            LoadThresholdOrders();
        }

        private void checkBoxAttacker_CheckedChanged(object sender, EventArgs e)
        {
            AttackerThresholdUpDown.Value = CheckThresholdValue(AttackerThresholdUpDown.Value, Settings.Instance.AttackerThresholdUseDrop);
            Settings.Instance.UseAttackerStance = checkBoxAttacker.Checked;
            Settings.Instance.Save();
            LoadThresholdOrders();
        }

        private void checkBoxDefender_CheckedChanged(object sender, EventArgs e)
        {
            DefenderThresholdUpDown.Value = CheckThresholdValue(DefenderThresholdUpDown.Value, Settings.Instance.DefenderThresholdUseDrop);
            Settings.Instance.UseDefenderStance = checkBoxDefender.Checked;
            Settings.Instance.Save();
            LoadThresholdOrders();
        }

        private void checkBoxFree_CheckedChanged(object sender, EventArgs e)
        {
            FreeThresholdUpDown.Value = CheckThresholdValue(FreeThresholdUpDown.Value, Settings.Instance.FreeThresholdUseDrop);
            Settings.Instance.UseFreeStance = checkBoxFree.Checked;
            Settings.Instance.Save();
            LoadThresholdOrders();
        }

        private void HealerThresholdUpDown_ValueChanged(object sender, EventArgs e)
        {
            HealerThresholdUpDown.Value = CheckThresholdValue(HealerThresholdUpDown.Value, Settings.Instance.HealerThresholdUseDrop);
            Settings.Instance.HealerThreshold = (float)HealerThresholdUpDown.Value;
            Settings.Instance.Save();
            LoadThresholdOrders();
        }

        private void AttackerThresholdUpDown_ValueChanged(object sender, EventArgs e)
        {
            AttackerThresholdUpDown.Value = CheckThresholdValue(AttackerThresholdUpDown.Value, Settings.Instance.AttackerThresholdUseDrop);
            Settings.Instance.AttackerThreshold = (float)AttackerThresholdUpDown.Value;
            Settings.Instance.Save();
            LoadThresholdOrders();
        }

        private void DefenderThresholdUpDown_ValueChanged(object sender, EventArgs e)
        {
            DefenderThresholdUpDown.Value = CheckThresholdValue(DefenderThresholdUpDown.Value, Settings.Instance.DefenderThresholdUseDrop);
            Settings.Instance.DefenderThreshold = (float)DefenderThresholdUpDown.Value;
            Settings.Instance.Save();
            LoadThresholdOrders();
        }

        private void FreeThresholdUpDown_ValueChanged(object sender, EventArgs e)
        {
            FreeThresholdUpDown.Value = CheckThresholdValue(FreeThresholdUpDown.Value, Settings.Instance.FreeThresholdUseDrop);
            Settings.Instance.FreeThreshold = (float)FreeThresholdUpDown.Value;
            Settings.Instance.Save();
            LoadThresholdOrders();
        }

        #region LoadThresholds

        public static void LoadThresholdOrders()
        {
            ChocoboCompanionStanceDancerPlugin.lowestThreshold1 = LowestThreshold1();

            if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 != 0)
            {
                ChocoboCompanionStanceDancerPlugin.lowestThreshold2 = LowestThreshold2();
            }
            else
            {
                ChocoboCompanionStanceDancerPlugin.lowestThresholdValue2 = 0;
                ChocoboCompanionStanceDancerPlugin.lowestThreshold2 = 0;
            }
            if (ChocoboCompanionStanceDancerPlugin.lowestThreshold2 != 0)
            {
                ChocoboCompanionStanceDancerPlugin.lowestThreshold3 = LowestThreshold3();
            }
            else
            {
                ChocoboCompanionStanceDancerPlugin.lowestThresholdValue3 = 0;
                ChocoboCompanionStanceDancerPlugin.lowestThreshold3 = 0;
            }
            if (ChocoboCompanionStanceDancerPlugin.lowestThreshold3 != 0)
            {
                ChocoboCompanionStanceDancerPlugin.lowestThreshold4 = LowestThreshold4();
            }
            else
            {
                ChocoboCompanionStanceDancerPlugin.lowestThresholdValue4 = 0;
                ChocoboCompanionStanceDancerPlugin.lowestThreshold4 = 0;
            }
            
            if (ChocoboCompanionStanceDancerPlugin.lowestThreshold4 != 0)
            {
                ChocoboCompanionStanceDancerPlugin.highestThreshold1 = 0;
                ChocoboCompanionStanceDancerPlugin.highestThreshold2 = 0;
                ChocoboCompanionStanceDancerPlugin.highestThreshold3 = 0;
                ChocoboCompanionStanceDancerPlugin.highestThreshold4 = 0;
                ChocoboCompanionStanceDancerPlugin.highestThresholdValue1 = 100;
                ChocoboCompanionStanceDancerPlugin.highestThresholdValue2 = 100;
                ChocoboCompanionStanceDancerPlugin.highestThresholdValue3 = 100;
                ChocoboCompanionStanceDancerPlugin.highestThresholdValue4 = 100;
            }
            else
            {
                ChocoboCompanionStanceDancerPlugin.highestThreshold1 = HighestThreshold1();

                if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 != 0)
                {
                    ChocoboCompanionStanceDancerPlugin.highestThreshold2 = HighestThreshold2();
                }
                else
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue2 = 100;
                    ChocoboCompanionStanceDancerPlugin.highestThreshold2 = 0;
                }
                if (ChocoboCompanionStanceDancerPlugin.highestThreshold2 != 0)
                {
                    ChocoboCompanionStanceDancerPlugin.highestThreshold3 = HighestThreshold3();
                }
                else
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue3 = 100;
                    ChocoboCompanionStanceDancerPlugin.highestThreshold3 = 0;
                }
                if (ChocoboCompanionStanceDancerPlugin.highestThreshold3 != 0)
                {
                    ChocoboCompanionStanceDancerPlugin.highestThreshold4 = HighestThreshold4();
                }
                else
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue4 = 100;
                    ChocoboCompanionStanceDancerPlugin.highestThreshold4 = 0;
                }
            }
        }

        private static CompanionStance LowestThreshold1()
        {
            if (Settings.Instance.UseHealerStance && Settings.Instance.HealerThresholdUseDrop &&
                (!Settings.Instance.UseAttackerStance || !Settings.Instance.AttackerThresholdUseDrop || Settings.Instance.HealerThreshold <= Settings.Instance.AttackerThreshold) &&
                (!Settings.Instance.UseDefenderStance || !Settings.Instance.DefenderThresholdUseDrop || Settings.Instance.HealerThreshold <= Settings.Instance.DefenderThreshold) &&
                (!Settings.Instance.UseFreeStance || !Settings.Instance.FreeThresholdUseDrop || Settings.Instance.HealerThreshold <= Settings.Instance.FreeThreshold))
            {
                ChocoboCompanionStanceDancerPlugin.lowestThresholdValue1 = Settings.Instance.HealerThreshold;
                return CompanionStance.Healer;
            }
            if (Settings.Instance.UseDefenderStance && Settings.Instance.DefenderThresholdUseDrop &&
                (!Settings.Instance.UseAttackerStance || !Settings.Instance.AttackerThresholdUseDrop || Settings.Instance.DefenderThreshold <= Settings.Instance.AttackerThreshold) &&
                (!Settings.Instance.UseFreeStance || !Settings.Instance.FreeThresholdUseDrop || Settings.Instance.DefenderThreshold <= Settings.Instance.FreeThreshold))
            {
                ChocoboCompanionStanceDancerPlugin.lowestThresholdValue1 = Settings.Instance.DefenderThreshold;
                return CompanionStance.Defender;
            }
            if (Settings.Instance.UseAttackerStance && Settings.Instance.AttackerThresholdUseDrop &&
                (!Settings.Instance.UseFreeStance || !Settings.Instance.FreeThresholdUseDrop || Settings.Instance.AttackerThreshold <= Settings.Instance.FreeThreshold))
            {
                ChocoboCompanionStanceDancerPlugin.lowestThresholdValue1 = Settings.Instance.AttackerThreshold;
                return CompanionStance.Attacker;
            }
            if (Settings.Instance.UseFreeStance && Settings.Instance.FreeThresholdUseDrop)
            {
                ChocoboCompanionStanceDancerPlugin.lowestThresholdValue1 = Settings.Instance.FreeThreshold;
                return CompanionStance.Free;
            }
            ChocoboCompanionStanceDancerPlugin.lowestThresholdValue1 = 0;
            return 0;
        }

        private static CompanionStance LowestThreshold2()
        {
            if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 == CompanionStance.Healer)
            {
                if (Settings.Instance.UseDefenderStance && Settings.Instance.DefenderThresholdUseDrop &&
                    (!Settings.Instance.UseAttackerStance || !Settings.Instance.AttackerThresholdUseDrop || Settings.Instance.DefenderThreshold <= Settings.Instance.AttackerThreshold) &&
                    (!Settings.Instance.UseFreeStance || !Settings.Instance.FreeThresholdUseDrop || Settings.Instance.DefenderThreshold <= Settings.Instance.FreeThreshold))
                {
                    ChocoboCompanionStanceDancerPlugin.lowestThresholdValue2 = Settings.Instance.DefenderThreshold;
                    return CompanionStance.Defender;
                }
                if (Settings.Instance.UseAttackerStance && Settings.Instance.AttackerThresholdUseDrop &&
                    (!Settings.Instance.UseFreeStance || !Settings.Instance.FreeThresholdUseDrop || Settings.Instance.AttackerThreshold <= Settings.Instance.FreeThreshold))
                {
                    ChocoboCompanionStanceDancerPlugin.lowestThresholdValue2 = Settings.Instance.AttackerThreshold;
                    return CompanionStance.Attacker;
                }
                if (Settings.Instance.UseFreeStance && Settings.Instance.FreeThresholdUseDrop)
                {
                    ChocoboCompanionStanceDancerPlugin.lowestThresholdValue2 = Settings.Instance.FreeThreshold;
                    return CompanionStance.Free;
                }
            }
            if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 == CompanionStance.Defender)
            {
                if (Settings.Instance.UseHealerStance && Settings.Instance.HealerThresholdUseDrop &&
                    (!Settings.Instance.UseAttackerStance || !Settings.Instance.AttackerThresholdUseDrop || Settings.Instance.HealerThreshold <= Settings.Instance.AttackerThreshold) &&
                    (!Settings.Instance.UseFreeStance || !Settings.Instance.FreeThresholdUseDrop || Settings.Instance.HealerThreshold <= Settings.Instance.FreeThreshold))
                {
                    ChocoboCompanionStanceDancerPlugin.lowestThresholdValue2 = Settings.Instance.HealerThreshold;
                    return CompanionStance.Healer;
                }
                if (Settings.Instance.UseAttackerStance && Settings.Instance.AttackerThresholdUseDrop &&
                    (!Settings.Instance.UseFreeStance || !Settings.Instance.FreeThresholdUseDrop || Settings.Instance.AttackerThreshold <= Settings.Instance.FreeThreshold))
                {
                    ChocoboCompanionStanceDancerPlugin.lowestThresholdValue2 = Settings.Instance.AttackerThreshold;
                    return CompanionStance.Attacker;
                }
                if (Settings.Instance.UseFreeStance && Settings.Instance.FreeThresholdUseDrop)
                {
                    ChocoboCompanionStanceDancerPlugin.lowestThresholdValue2 = Settings.Instance.FreeThreshold;
                    return CompanionStance.Free;
                }
            }
            if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 == CompanionStance.Attacker)
            {
                if (Settings.Instance.UseHealerStance && Settings.Instance.HealerThresholdUseDrop &&
                    (!Settings.Instance.UseDefenderStance || !Settings.Instance.DefenderThresholdUseDrop || Settings.Instance.HealerThreshold <= Settings.Instance.DefenderThreshold) &&
                    (!Settings.Instance.UseFreeStance || !Settings.Instance.FreeThresholdUseDrop || Settings.Instance.HealerThreshold <= Settings.Instance.FreeThreshold))
                {
                    ChocoboCompanionStanceDancerPlugin.lowestThresholdValue2 = Settings.Instance.HealerThreshold;
                    return CompanionStance.Healer;
                }
                if (Settings.Instance.UseDefenderStance && Settings.Instance.DefenderThresholdUseDrop &&
                    (!Settings.Instance.UseFreeStance || !Settings.Instance.FreeThresholdUseDrop || Settings.Instance.DefenderThreshold <= Settings.Instance.FreeThreshold))
                {
                    ChocoboCompanionStanceDancerPlugin.lowestThresholdValue2 = Settings.Instance.DefenderThreshold;
                    return CompanionStance.Defender;
                }
                if (Settings.Instance.UseFreeStance && Settings.Instance.FreeThresholdUseDrop)
                {
                    ChocoboCompanionStanceDancerPlugin.lowestThresholdValue2 = Settings.Instance.FreeThreshold;
                    return CompanionStance.Free;
                }
            }
            if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 == CompanionStance.Free)
            {
                if (Settings.Instance.UseHealerStance && Settings.Instance.HealerThresholdUseDrop &&
                    (!Settings.Instance.UseAttackerStance || !Settings.Instance.AttackerThresholdUseDrop || Settings.Instance.HealerThreshold <= Settings.Instance.AttackerThreshold) &&
                    (!Settings.Instance.UseDefenderStance || !Settings.Instance.DefenderThresholdUseDrop || Settings.Instance.HealerThreshold <= Settings.Instance.DefenderThreshold))
                {
                    ChocoboCompanionStanceDancerPlugin.lowestThresholdValue2 = Settings.Instance.HealerThreshold;
                    return CompanionStance.Healer;
                }
                if (Settings.Instance.UseDefenderStance && Settings.Instance.DefenderThresholdUseDrop &&
                    (!Settings.Instance.UseAttackerStance || !Settings.Instance.AttackerThresholdUseDrop || Settings.Instance.DefenderThreshold <= Settings.Instance.AttackerThreshold))
                {
                    ChocoboCompanionStanceDancerPlugin.lowestThresholdValue2 = Settings.Instance.DefenderThreshold;
                    return CompanionStance.Defender;
                }
                if (Settings.Instance.UseAttackerStance && Settings.Instance.AttackerThresholdUseDrop)
                {
                    ChocoboCompanionStanceDancerPlugin.lowestThresholdValue2 = Settings.Instance.AttackerThreshold;
                    return CompanionStance.Attacker;
                }
            }
            ChocoboCompanionStanceDancerPlugin.lowestThresholdValue2 = 0;
            return 0;
        }

        private static CompanionStance LowestThreshold3()
        {
            if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 == CompanionStance.Healer || ChocoboCompanionStanceDancerPlugin.lowestThreshold2 == CompanionStance.Healer)
            {
                if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 == CompanionStance.Defender || ChocoboCompanionStanceDancerPlugin.lowestThreshold2 == CompanionStance.Defender)
                {
                    if (Settings.Instance.UseAttackerStance && Settings.Instance.AttackerThresholdUseDrop &&
                        (!Settings.Instance.UseFreeStance || !Settings.Instance.FreeThresholdUseDrop || Settings.Instance.AttackerThreshold <= Settings.Instance.FreeThreshold))
                    {
                        ChocoboCompanionStanceDancerPlugin.lowestThresholdValue3 = Settings.Instance.AttackerThreshold;
                        return CompanionStance.Attacker;
                    }
                    if (Settings.Instance.UseFreeStance && Settings.Instance.FreeThresholdUseDrop)
                    {
                        ChocoboCompanionStanceDancerPlugin.lowestThresholdValue3 = Settings.Instance.FreeThreshold;
                        return CompanionStance.Free;
                    }
                }
                if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 == CompanionStance.Attacker || ChocoboCompanionStanceDancerPlugin.lowestThreshold2 == CompanionStance.Attacker)
                {
                    if (Settings.Instance.UseDefenderStance && Settings.Instance.DefenderThresholdUseDrop &&
                        (!Settings.Instance.UseFreeStance || !Settings.Instance.FreeThresholdUseDrop || Settings.Instance.DefenderThreshold <= Settings.Instance.FreeThreshold))
                    {
                        ChocoboCompanionStanceDancerPlugin.lowestThresholdValue3 = Settings.Instance.DefenderThreshold;
                        return CompanionStance.Defender;
                    }
                    if (Settings.Instance.UseFreeStance && Settings.Instance.FreeThresholdUseDrop)
                    {
                        ChocoboCompanionStanceDancerPlugin.lowestThresholdValue3 = Settings.Instance.FreeThreshold;
                        return CompanionStance.Free;
                    }
                }
                if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 == CompanionStance.Free || ChocoboCompanionStanceDancerPlugin.lowestThreshold2 == CompanionStance.Free)
                {
                    if (Settings.Instance.UseDefenderStance && Settings.Instance.DefenderThresholdUseDrop &&
                        (!Settings.Instance.UseAttackerStance || !Settings.Instance.AttackerThresholdUseDrop || Settings.Instance.DefenderThreshold <= Settings.Instance.AttackerThreshold))
                    {
                        ChocoboCompanionStanceDancerPlugin.lowestThresholdValue3 = Settings.Instance.DefenderThreshold;
                        return CompanionStance.Defender;
                    }
                    if (Settings.Instance.UseAttackerStance && Settings.Instance.AttackerThresholdUseDrop)
                    {
                        ChocoboCompanionStanceDancerPlugin.lowestThresholdValue3 = Settings.Instance.AttackerThreshold;
                        return CompanionStance.Attacker;
                    }
                }
            }
            if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 == CompanionStance.Defender || ChocoboCompanionStanceDancerPlugin.lowestThreshold2 == CompanionStance.Defender)
            {
                if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 == CompanionStance.Attacker || ChocoboCompanionStanceDancerPlugin.lowestThreshold2 == CompanionStance.Attacker)
                {
                    if (Settings.Instance.UseHealerStance && Settings.Instance.HealerThresholdUseDrop &&
                        (!Settings.Instance.UseFreeStance || !Settings.Instance.FreeThresholdUseDrop || Settings.Instance.HealerThreshold <= Settings.Instance.FreeThreshold))
                    {
                        ChocoboCompanionStanceDancerPlugin.lowestThresholdValue3 = Settings.Instance.HealerThreshold;
                        return CompanionStance.Healer;
                    }
                    if (Settings.Instance.UseFreeStance && Settings.Instance.FreeThresholdUseDrop)
                    {
                        ChocoboCompanionStanceDancerPlugin.lowestThresholdValue3 = Settings.Instance.FreeThreshold;
                        return CompanionStance.Free;
                    }
                }
                if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 == CompanionStance.Free || ChocoboCompanionStanceDancerPlugin.lowestThreshold2 == CompanionStance.Free)
                {
                    if (Settings.Instance.UseHealerStance && Settings.Instance.HealerThresholdUseDrop &&
                        (!Settings.Instance.UseAttackerStance || !Settings.Instance.AttackerThresholdUseDrop || Settings.Instance.HealerThreshold <= Settings.Instance.AttackerThreshold))
                    {
                        ChocoboCompanionStanceDancerPlugin.lowestThresholdValue3 = Settings.Instance.HealerThreshold;
                        return CompanionStance.Healer;
                    }
                    if (Settings.Instance.UseAttackerStance && Settings.Instance.AttackerThresholdUseDrop)
                    {
                        ChocoboCompanionStanceDancerPlugin.lowestThresholdValue3 = Settings.Instance.AttackerThreshold;
                        return CompanionStance.Attacker;
                    }
                }
            }
            if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 == CompanionStance.Attacker || ChocoboCompanionStanceDancerPlugin.lowestThreshold2 == CompanionStance.Attacker)
            {
                if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 == CompanionStance.Free || ChocoboCompanionStanceDancerPlugin.lowestThreshold2 == CompanionStance.Free)
                {
                    if (Settings.Instance.UseHealerStance && Settings.Instance.HealerThresholdUseDrop &&
                        (!Settings.Instance.UseDefenderStance || !Settings.Instance.DefenderThresholdUseDrop || Settings.Instance.HealerThreshold <= Settings.Instance.DefenderThreshold))
                    {
                        ChocoboCompanionStanceDancerPlugin.lowestThresholdValue3 = Settings.Instance.HealerThreshold;
                        return CompanionStance.Healer;
                    }
                    if (Settings.Instance.UseDefenderStance && Settings.Instance.DefenderThresholdUseDrop)
                    {
                        ChocoboCompanionStanceDancerPlugin.lowestThresholdValue3 = Settings.Instance.DefenderThreshold;
                        return CompanionStance.Defender;
                    }
                }
            }
            ChocoboCompanionStanceDancerPlugin.lowestThresholdValue3 = 0;
            return 0;
        }

        private static CompanionStance LowestThreshold4()
        {
            if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 != CompanionStance.Healer && ChocoboCompanionStanceDancerPlugin.lowestThreshold2 != CompanionStance.Healer && ChocoboCompanionStanceDancerPlugin.lowestThreshold3 != CompanionStance.Healer)
            {
                if (Settings.Instance.UseHealerStance && Settings.Instance.HealerThresholdUseDrop)
                {
                    ChocoboCompanionStanceDancerPlugin.lowestThresholdValue4 = Settings.Instance.HealerThreshold;
                    return CompanionStance.Healer;
                }
            }
            if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 != CompanionStance.Defender && ChocoboCompanionStanceDancerPlugin.lowestThreshold2 != CompanionStance.Defender && ChocoboCompanionStanceDancerPlugin.lowestThreshold3 != CompanionStance.Defender)
            {
                if (Settings.Instance.UseDefenderStance && Settings.Instance.DefenderThresholdUseDrop)
                {
                    ChocoboCompanionStanceDancerPlugin.lowestThresholdValue4 = Settings.Instance.DefenderThreshold;
                    return CompanionStance.Defender;
                }
            }
            if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 != CompanionStance.Attacker && ChocoboCompanionStanceDancerPlugin.lowestThreshold2 != CompanionStance.Attacker && ChocoboCompanionStanceDancerPlugin.lowestThreshold3 != CompanionStance.Attacker)
            {
                if (Settings.Instance.UseAttackerStance && Settings.Instance.AttackerThresholdUseDrop)
                {
                    ChocoboCompanionStanceDancerPlugin.lowestThresholdValue4 = Settings.Instance.AttackerThreshold;
                    return CompanionStance.Attacker;
                }
            }
            if (ChocoboCompanionStanceDancerPlugin.lowestThreshold1 != CompanionStance.Free && ChocoboCompanionStanceDancerPlugin.lowestThreshold2 != CompanionStance.Free && ChocoboCompanionStanceDancerPlugin.lowestThreshold3 != CompanionStance.Free)
            {
                if (Settings.Instance.UseFreeStance && Settings.Instance.FreeThresholdUseDrop)
                {
                    ChocoboCompanionStanceDancerPlugin.lowestThresholdValue4 = Settings.Instance.FreeThreshold;
                    return CompanionStance.Free;
                }
            }
            ChocoboCompanionStanceDancerPlugin.lowestThresholdValue4 = 0;
            return 0;
        }

        private static CompanionStance HighestThreshold1()
        {
            if (Settings.Instance.UseHealerStance && !Settings.Instance.HealerThresholdUseDrop &&
                (!Settings.Instance.UseAttackerStance || Settings.Instance.AttackerThresholdUseDrop || Settings.Instance.HealerThreshold >= Settings.Instance.AttackerThreshold) &&
                (!Settings.Instance.UseDefenderStance || Settings.Instance.DefenderThresholdUseDrop || Settings.Instance.HealerThreshold >= Settings.Instance.DefenderThreshold) &&
                (!Settings.Instance.UseFreeStance || Settings.Instance.FreeThresholdUseDrop || Settings.Instance.HealerThreshold >= Settings.Instance.FreeThreshold))
            {
                ChocoboCompanionStanceDancerPlugin.highestThresholdValue1 = Settings.Instance.HealerThreshold;
                return CompanionStance.Healer;
            }
            if (Settings.Instance.UseDefenderStance && !Settings.Instance.DefenderThresholdUseDrop &&
                (!Settings.Instance.UseAttackerStance || Settings.Instance.AttackerThresholdUseDrop || Settings.Instance.DefenderThreshold >= Settings.Instance.AttackerThreshold) &&
                (!Settings.Instance.UseFreeStance || Settings.Instance.FreeThresholdUseDrop || Settings.Instance.DefenderThreshold >= Settings.Instance.FreeThreshold))
            {
                ChocoboCompanionStanceDancerPlugin.highestThresholdValue1 = Settings.Instance.DefenderThreshold;
                return CompanionStance.Defender;
            }
            if (Settings.Instance.UseAttackerStance && !Settings.Instance.AttackerThresholdUseDrop &&
                (!Settings.Instance.UseFreeStance || Settings.Instance.FreeThresholdUseDrop || Settings.Instance.AttackerThreshold >= Settings.Instance.FreeThreshold))
            {
                ChocoboCompanionStanceDancerPlugin.highestThresholdValue1 = Settings.Instance.AttackerThreshold;
                return CompanionStance.Attacker;
            }
            if (Settings.Instance.UseFreeStance && !Settings.Instance.FreeThresholdUseDrop)
            {
                ChocoboCompanionStanceDancerPlugin.highestThresholdValue1 = Settings.Instance.FreeThreshold;
                return CompanionStance.Free;
            }
            ChocoboCompanionStanceDancerPlugin.highestThresholdValue1 = 100;
            return 0;
        }

        private static CompanionStance HighestThreshold2()
        {
            if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 == CompanionStance.Healer)
            {
                if (Settings.Instance.UseDefenderStance && !Settings.Instance.DefenderThresholdUseDrop &&
                    (!Settings.Instance.UseAttackerStance || Settings.Instance.AttackerThresholdUseDrop || Settings.Instance.DefenderThreshold >= Settings.Instance.AttackerThreshold) &&
                    (!Settings.Instance.UseFreeStance || Settings.Instance.FreeThresholdUseDrop || Settings.Instance.DefenderThreshold >= Settings.Instance.FreeThreshold))
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue2 = Settings.Instance.DefenderThreshold;
                    return CompanionStance.Defender;
                }
                if (Settings.Instance.UseAttackerStance && !Settings.Instance.AttackerThresholdUseDrop &&
                    (!Settings.Instance.UseFreeStance ||!Settings.Instance.FreeThresholdUseDrop || Settings.Instance.AttackerThreshold >= Settings.Instance.FreeThreshold))
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue2 = Settings.Instance.AttackerThreshold;
                    return CompanionStance.Attacker;
                }
                if (Settings.Instance.UseFreeStance && !Settings.Instance.FreeThresholdUseDrop)
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue2 = Settings.Instance.FreeThreshold;
                    return CompanionStance.Free;
                }
            }
            if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 == CompanionStance.Defender)
            {
                if (Settings.Instance.UseHealerStance && !Settings.Instance.HealerThresholdUseDrop &&
                    (!Settings.Instance.UseAttackerStance || Settings.Instance.AttackerThresholdUseDrop || Settings.Instance.HealerThreshold >= Settings.Instance.AttackerThreshold) &&
                    (!Settings.Instance.UseFreeStance || Settings.Instance.FreeThresholdUseDrop || Settings.Instance.HealerThreshold >= Settings.Instance.FreeThreshold))
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue2 = Settings.Instance.HealerThreshold;
                    return CompanionStance.Healer;
                }
                if (Settings.Instance.UseAttackerStance && !Settings.Instance.AttackerThresholdUseDrop &&
                    (!Settings.Instance.UseFreeStance || Settings.Instance.FreeThresholdUseDrop || Settings.Instance.AttackerThreshold >= Settings.Instance.FreeThreshold))
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue2 = Settings.Instance.AttackerThreshold;
                    return CompanionStance.Attacker;
                }
                if (Settings.Instance.UseFreeStance && !Settings.Instance.FreeThresholdUseDrop)
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue2 = Settings.Instance.FreeThreshold;
                    return CompanionStance.Free;
                }
            }
            if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 == CompanionStance.Attacker)
            {
                if (Settings.Instance.UseHealerStance && !Settings.Instance.HealerThresholdUseDrop &&
                    (!Settings.Instance.UseDefenderStance || Settings.Instance.DefenderThresholdUseDrop || Settings.Instance.HealerThreshold >= Settings.Instance.DefenderThreshold) &&
                    (!Settings.Instance.UseFreeStance || Settings.Instance.FreeThresholdUseDrop || Settings.Instance.HealerThreshold >= Settings.Instance.FreeThreshold))
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue2 = Settings.Instance.HealerThreshold;
                    return CompanionStance.Healer;
                }
                if (Settings.Instance.UseDefenderStance && !Settings.Instance.DefenderThresholdUseDrop &&
                    (!Settings.Instance.UseFreeStance || Settings.Instance.FreeThresholdUseDrop || Settings.Instance.DefenderThreshold >= Settings.Instance.FreeThreshold))
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue2 = Settings.Instance.DefenderThreshold;
                    return CompanionStance.Defender;
                }
                if (Settings.Instance.UseFreeStance && !Settings.Instance.FreeThresholdUseDrop)
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue2 = Settings.Instance.FreeThreshold;
                    return CompanionStance.Free;
                }
            }
            if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 == CompanionStance.Free)
            {
                if (Settings.Instance.UseHealerStance && !Settings.Instance.HealerThresholdUseDrop &&
                    (!Settings.Instance.UseAttackerStance || Settings.Instance.AttackerThresholdUseDrop || Settings.Instance.HealerThreshold >= Settings.Instance.AttackerThreshold) &&
                    (!Settings.Instance.UseDefenderStance || Settings.Instance.DefenderThresholdUseDrop || Settings.Instance.HealerThreshold >= Settings.Instance.DefenderThreshold))
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue2 = Settings.Instance.HealerThreshold;
                    return CompanionStance.Healer;
                }
                if (Settings.Instance.UseDefenderStance && !Settings.Instance.DefenderThresholdUseDrop &&
                    (!Settings.Instance.UseAttackerStance || Settings.Instance.AttackerThresholdUseDrop || Settings.Instance.DefenderThreshold >= Settings.Instance.AttackerThreshold))
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue2 = Settings.Instance.DefenderThreshold;
                    return CompanionStance.Defender;
                }
                if (Settings.Instance.UseAttackerStance && !Settings.Instance.AttackerThresholdUseDrop)
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue2 = Settings.Instance.AttackerThreshold;
                    return CompanionStance.Attacker;
                }
            }
            ChocoboCompanionStanceDancerPlugin.highestThresholdValue2 = 100;
            return 0;
        }

        private static CompanionStance HighestThreshold3()
        {
            if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 == CompanionStance.Healer || ChocoboCompanionStanceDancerPlugin.highestThreshold2 == CompanionStance.Healer)
            {
                if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 == CompanionStance.Defender || ChocoboCompanionStanceDancerPlugin.highestThreshold2 == CompanionStance.Defender)
                {
                    if (Settings.Instance.UseAttackerStance && !Settings.Instance.AttackerThresholdUseDrop &&
                        (!Settings.Instance.UseFreeStance || Settings.Instance.FreeThresholdUseDrop || Settings.Instance.AttackerThreshold >= Settings.Instance.FreeThreshold))
                    {
                        ChocoboCompanionStanceDancerPlugin.highestThresholdValue3 = Settings.Instance.AttackerThreshold;
                        return CompanionStance.Attacker;
                    }
                    if (Settings.Instance.UseFreeStance && !Settings.Instance.FreeThresholdUseDrop)
                    {
                        ChocoboCompanionStanceDancerPlugin.highestThresholdValue3 = Settings.Instance.FreeThreshold;
                        return CompanionStance.Free;
                    }
                }
                if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 == CompanionStance.Attacker || ChocoboCompanionStanceDancerPlugin.highestThreshold2 == CompanionStance.Attacker)
                {
                    if (Settings.Instance.UseDefenderStance && !Settings.Instance.DefenderThresholdUseDrop &&
                        (!Settings.Instance.UseFreeStance || Settings.Instance.FreeThresholdUseDrop || Settings.Instance.DefenderThreshold >= Settings.Instance.FreeThreshold))
                    {
                        ChocoboCompanionStanceDancerPlugin.highestThresholdValue3 = Settings.Instance.DefenderThreshold;
                        return CompanionStance.Defender;
                    }
                    if (Settings.Instance.UseFreeStance && !Settings.Instance.FreeThresholdUseDrop)
                    {
                        ChocoboCompanionStanceDancerPlugin.highestThresholdValue3 = Settings.Instance.FreeThreshold;
                        return CompanionStance.Free;
                    }
                }
                if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 == CompanionStance.Free || ChocoboCompanionStanceDancerPlugin.highestThreshold2 == CompanionStance.Free)
                {
                    if (Settings.Instance.UseDefenderStance && !Settings.Instance.DefenderThresholdUseDrop &&
                        (!Settings.Instance.UseAttackerStance || Settings.Instance.AttackerThresholdUseDrop || Settings.Instance.DefenderThreshold >= Settings.Instance.AttackerThreshold))
                    {
                        ChocoboCompanionStanceDancerPlugin.highestThresholdValue3 = Settings.Instance.DefenderThreshold;
                        return CompanionStance.Defender;
                    }
                    if (Settings.Instance.UseAttackerStance && !Settings.Instance.AttackerThresholdUseDrop)
                    {
                        ChocoboCompanionStanceDancerPlugin.highestThresholdValue3 = Settings.Instance.AttackerThreshold;
                        return CompanionStance.Attacker;
                    }
                }
            }
            if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 == CompanionStance.Defender || ChocoboCompanionStanceDancerPlugin.highestThreshold2 == CompanionStance.Defender)
            {
                if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 == CompanionStance.Attacker || ChocoboCompanionStanceDancerPlugin.highestThreshold2 == CompanionStance.Attacker)
                {
                    if (Settings.Instance.UseHealerStance && !Settings.Instance.HealerThresholdUseDrop &&
                        (!Settings.Instance.UseFreeStance || Settings.Instance.FreeThresholdUseDrop || Settings.Instance.HealerThreshold >= Settings.Instance.FreeThreshold))
                    {
                        ChocoboCompanionStanceDancerPlugin.highestThresholdValue3 = Settings.Instance.HealerThreshold;
                        return CompanionStance.Healer;
                    }
                    if (Settings.Instance.UseFreeStance && !Settings.Instance.FreeThresholdUseDrop)
                    {
                        ChocoboCompanionStanceDancerPlugin.highestThresholdValue3 = Settings.Instance.FreeThreshold;
                        return CompanionStance.Free;
                    }
                }
                if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 == CompanionStance.Free || ChocoboCompanionStanceDancerPlugin.highestThreshold2 == CompanionStance.Free)
                {
                    if (Settings.Instance.UseHealerStance && !Settings.Instance.HealerThresholdUseDrop &&
                        (!Settings.Instance.UseAttackerStance || Settings.Instance.AttackerThresholdUseDrop || Settings.Instance.HealerThreshold >= Settings.Instance.AttackerThreshold))
                    {
                        ChocoboCompanionStanceDancerPlugin.highestThresholdValue3 = Settings.Instance.HealerThreshold;
                        return CompanionStance.Healer;
                    }
                    if (Settings.Instance.UseAttackerStance && !Settings.Instance.AttackerThresholdUseDrop)
                    {
                        ChocoboCompanionStanceDancerPlugin.highestThresholdValue3 = Settings.Instance.AttackerThreshold;
                        return CompanionStance.Attacker;
                    }
                }
            }
            if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 == CompanionStance.Attacker || ChocoboCompanionStanceDancerPlugin.highestThreshold2 == CompanionStance.Attacker)
            {
                if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 == CompanionStance.Free || ChocoboCompanionStanceDancerPlugin.highestThreshold2 == CompanionStance.Free)
                {
                    if (Settings.Instance.UseHealerStance && !Settings.Instance.HealerThresholdUseDrop &&
                        (!Settings.Instance.UseDefenderStance || Settings.Instance.DefenderThresholdUseDrop || Settings.Instance.HealerThreshold >= Settings.Instance.DefenderThreshold))
                    {
                        ChocoboCompanionStanceDancerPlugin.highestThresholdValue3 = Settings.Instance.HealerThreshold;
                        return CompanionStance.Healer;
                    }
                    if (Settings.Instance.UseDefenderStance && !Settings.Instance.DefenderThresholdUseDrop)
                    {
                        ChocoboCompanionStanceDancerPlugin.highestThresholdValue3 = Settings.Instance.DefenderThreshold;
                        return CompanionStance.Defender;
                    }
                }
            }
            ChocoboCompanionStanceDancerPlugin.highestThresholdValue3 = 100;
            return 0;
        }

        private static CompanionStance HighestThreshold4()
        {
            if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 != CompanionStance.Healer && ChocoboCompanionStanceDancerPlugin.highestThreshold2 != CompanionStance.Healer && ChocoboCompanionStanceDancerPlugin.highestThreshold3 != CompanionStance.Healer)
            {
                if (Settings.Instance.UseHealerStance && !Settings.Instance.HealerThresholdUseDrop)
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue4 = Settings.Instance.HealerThreshold;
                    return CompanionStance.Healer;
                }
            }
            if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 != CompanionStance.Defender && ChocoboCompanionStanceDancerPlugin.highestThreshold2 != CompanionStance.Defender && ChocoboCompanionStanceDancerPlugin.highestThreshold3 != CompanionStance.Defender)
            {
                if (Settings.Instance.UseDefenderStance && !Settings.Instance.DefenderThresholdUseDrop)
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue4 = Settings.Instance.DefenderThreshold;
                    return CompanionStance.Defender;
                }
            }
            if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 != CompanionStance.Attacker && ChocoboCompanionStanceDancerPlugin.highestThreshold2 != CompanionStance.Attacker && ChocoboCompanionStanceDancerPlugin.highestThreshold3 != CompanionStance.Attacker)
            {
                if (Settings.Instance.UseAttackerStance && !Settings.Instance.AttackerThresholdUseDrop)
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue4 = Settings.Instance.AttackerThreshold;
                    return CompanionStance.Attacker;
                }
            }
            if (ChocoboCompanionStanceDancerPlugin.highestThreshold1 != CompanionStance.Free && ChocoboCompanionStanceDancerPlugin.highestThreshold2 != CompanionStance.Free && ChocoboCompanionStanceDancerPlugin.highestThreshold3 != CompanionStance.Free)
            {
                if (Settings.Instance.UseFreeStance && !Settings.Instance.FreeThresholdUseDrop)
                {
                    ChocoboCompanionStanceDancerPlugin.highestThresholdValue4 = Settings.Instance.FreeThreshold;
                    return CompanionStance.Free;
                }
            }
            ChocoboCompanionStanceDancerPlugin.highestThresholdValue4 = 100;
            return 0;
        }

        #endregion

        private static decimal CheckThresholdValue(decimal value, bool useHighest)
        {
            if (useHighest) value = (decimal)CheckHighestThresholdValue((float)value);
            else value = (decimal)CheckLowestThresholdValue((float)value);
            return value;
        }

        private static float CheckHighestThresholdValue(float value)
        {
            if (value > ChocoboCompanionStanceDancerPlugin.highestThresholdValue4) return ChocoboCompanionStanceDancerPlugin.highestThresholdValue4;
            if (value > ChocoboCompanionStanceDancerPlugin.highestThresholdValue3) return ChocoboCompanionStanceDancerPlugin.highestThresholdValue3;
            if (value > ChocoboCompanionStanceDancerPlugin.highestThresholdValue2) return ChocoboCompanionStanceDancerPlugin.highestThresholdValue2;
            if (value > ChocoboCompanionStanceDancerPlugin.highestThresholdValue1) return ChocoboCompanionStanceDancerPlugin.highestThresholdValue1;
            return value;
        }

        private static float CheckLowestThresholdValue(float value)
        {
            if (value < ChocoboCompanionStanceDancerPlugin.lowestThresholdValue4) return ChocoboCompanionStanceDancerPlugin.lowestThresholdValue4;
            if (value < ChocoboCompanionStanceDancerPlugin.lowestThresholdValue3) return ChocoboCompanionStanceDancerPlugin.lowestThresholdValue3;
            if (value < ChocoboCompanionStanceDancerPlugin.lowestThresholdValue2) return ChocoboCompanionStanceDancerPlugin.lowestThresholdValue2;
            if (value < ChocoboCompanionStanceDancerPlugin.lowestThresholdValue1) return ChocoboCompanionStanceDancerPlugin.lowestThresholdValue1;
            return value;
        }

        private void checkBoxChocoboHealth_CheckedChanged(object sender, EventArgs e)
        {
            Settings.Instance.CheckChocoboHealth = checkBoxChocoboHealth.Checked;
            Settings.Instance.Save();
        }

        private void checkBoxPartyHealth_CheckedChanged(object sender, EventArgs e)
        {
            Settings.Instance.CheckPartyHealth = checkBoxPartyHealth.Checked;
            Settings.Instance.Save();
        }

        private void checkBoxSummonChocobo_CheckedChanged(object sender, EventArgs e)
        {
            Settings.Instance.SummonChocobo = checkBoxSummonChocobo.Checked;
            Settings.Instance.Save();
        }
    }
}
 